/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description 		    : 1շʾ
 *******************************************************************************/

#include "CH57x_common.h"
#include "HAL.h"
#include  <string.h>
UINT8 TxBuff[] = "This is a tx exam\r\n";
UINT8 RxBuff[100];
UINT8 TmpRxBuff[100];
UINT8 trigB;

int main()
{
  UINT8 len;
  UINT8 i = 0;
  UINT8 j = 0;
  SetSysClock( CLK_SOURCE_PLL_60MHz );
  HAL_TimeInit();
  
  /* ô1IOģʽô */
  GPIOA_SetBits( GPIO_Pin_9 );
  GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeIN_PU );			// RXD-
  GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );    // TXD-עIOߵƽ
  UART1_DefInit();
  /* ôڵ */
  //DebugInit();
  PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );

  
#if 1       // Դڷַ
  UART1_SendString( TxBuff, sizeof( TxBuff ) );
#endif   
  PRINT("R8_GLOB_RESET_KEEP:%d\n",R8_GLOB_RESET_KEEP);
  if(R8_GLOB_RESET_KEEP == 0){
       SYS_ResetKeepBuf(1);
       //GPIOB_SetBits( GPIO_Pin_15 );
       PRINT("len = 0\n");
   }else{
        SYS_ResetKeepBuf(0);
        PRINT("len = 1\n");
   }


  RTC_TMRFunCfg(Period_4_S);
      PFIC_EnableIRQ(RTC_IRQn);
      //PWR_UnitModCfg(DISABLE,0x1);
      PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_RTC_WAKE, Edge_ShortDelay );
      DelayMs( 2 );
      LowPower_Shutdown( 0 );                          //ȫϵ磬Ѻλ
#if 0      // ѯʽݺͳȥ
  while( 1 )
  {
    len = UART1_RecvString( RxBuff );
    if ( len )
    {
      PRINT("len=%d\n",len);
//      strncpy( TmpRxBuff + i, RxBuff, len );
//      i += len;
//      if ( i > 2 && i <= 100 )
//      {
//        if ( TmpRxBuff[0] == '1' && TmpRxBuff[1] == '2' )
//        {
//          UART1_SendString( TmpRxBuff, i );
//          i = 0;
//        }
//        else
//        {
//          i =0;
//        }
//      }
//      else if ( i > 100 )
//      {
//        UART1_SendString( TmpRxBuff, 100 );
//        i = 0;
//      }
    }
  }
#endif    
  
#if 0      // жϷʽݺͳȥ
  UART1_ByteTrigCfg( UART_7BYTE_TRIG );
  trigB = 7;
  UART1_INTCfg( ENABLE, RB_IER_RECV_RDY|RB_IER_LINE_STAT );
  PFIC_EnableIRQ( UART1_IRQn );
#endif    
  
  while( 1 )
    ;
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void UART1_IRQHandler( void )
{
  UINT8V i;
  
  switch ( UART1_GetITFlag() )
  {
    case UART_II_LINE_STAT :        // ·״̬
    {
      UART1_GetLinSTA();
      break;
    }
      
    case UART_II_RECV_RDY :          // ݴﵽô
      for ( i = 0; i != trigB; i++ )
      {
        RxBuff[i] = UART1_RecvByte();
        UART1_SendByte( RxBuff[i] );
      }
      break;
      
    case UART_II_RECV_TOUT :         // ճʱʱһ֡ݽ
      i = UART1_RecvString( RxBuff );
      UART1_SendString( RxBuff, i );
      break;
      
    case UART_II_THR_EMPTY :         // ͻգɼ
      break;
      
    case UART_II_MODEM_CHG :         // ִֻ֧0
      break;
      
    default :
      break;
  }
  
}

